﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private cvs As Canvas
	Dim fx As JFX
End Sub

Public Sub Initialize(c As Canvas)
	cvs = c
	
End Sub

public Sub DrawSphere(xAngle As Float, yAngle As Float) As Canvas
	cvs.ClearRect(0, 0, cvs.Width, cvs.Height)
	Dim radius As Float = Min(cvs.Width, cvs.Height) / 3
	Dim centerX As Float = cvs.Width / 2
	Dim centerY As Float = cvs.Height / 2

	For lat = -90 To 90 Step 5
		For lon = -180 To 180 Step 5
			Dim x1, y1, z1 As Float
			x1 = radius * CosD(lat) * CosD(lon)
			y1 = radius * CosD(lat) * SinD(lon)
			z1 = radius * SinD(lat)

			Dim x2, y2 As Float
			x2 = centerX + x1 * CosD(yAngle) - z1 * SinD(yAngle)
			y2 = centerY + y1 * CosD(xAngle) - (x1 * SinD(yAngle) + z1 * CosD(yAngle)) * SinD(xAngle)

			cvs.DrawCircle(x2, y2, 1, fx.Colors.Black, True, 1)
		Next
	
	Next
	Return cvs
End Sub

